package com.sosnoski.person;

import java.util.Date;

public class PersonLookup implements Person
{
    private static final PersonBean[] s_beans =
    {
        new PersonBean("Amy", "Adler", new Date(52, 4, 3), 0),
        new PersonBean("Bill", "Brunner", new Date(48, 10, 7), 1),
        new PersonBean("Christy", "Conner", new Date(66, 3, 22), 2),
        new PersonBean("David", "Drake", new Date(75, 11, 13), 3),
        new PersonBean("Evie", "Evans", new Date(59, 1, 27), 4),
        new PersonBean("Fred", "Fredricks", new Date(72, 7, 13), 5),
        new PersonBean("Gerty", "Grundy", new Date(42, 5, 21), 6),
        new PersonBean("Henry", "Hanks", new Date(71, 3, 31), 7),
        new PersonBean("India", "Isline", new Date(64, 6, 8), 8),
        new PersonBean("John", "Jackson", new Date(69, 0, 11), 9),
    };
    
    public PersonBean getPerson(int index) throws NoPersonException {
        if (index >= 0 && index < s_beans.length) {
            return s_beans[index];
        } else {
            throw new NoPersonException("Index " + index +
                " is out of the range 0-" + (s_beans.length-1));
        }
    }
    
    public PersonBean[] getAllPersons() throws java.rmi.RemoteException {
        return s_beans;
    }
    
    public PersonBean findPerson(String fname, String lname, Date born)
        throws NoPersonException {
        for (int i = 0; i < s_beans.length; i++) {
            PersonBean person = s_beans[i];
            if ((fname == null || person.getFName().equals(fname)) &&
                (lname == null || person.getLName().equals(lname)) &&
                (born == null || person.getBorn().equals(born))) {
                return person;
            }
        }
        String text = "No person found with";
        if (fname != null) {
            text += " fname=" + fname;
        }
        if (lname != null) {
            text += " lname=" + fname;
        }
        if (born != null) {
            text += " born=" + born;
        }
        throw new NoPersonException(text);
    }
}
